import {
    BlockLocation,
} from "mojang-minecraft";
import {
    JSONRequest,
    Player,
    Vector3
} from "../../modules/mbcore.js";
let settings = {};

function checkBlock(block, id) {
    if (!settings[id]) {
        settings[id] = {
            propIndex: 0,
            blockId: "",
        };
    }
    let plrOpts = settings[id];
    let newBlockId = block.permutation.type.id;
    if (plrOpts.blockId !== newBlockId) {
        plrOpts.blockId = newBlockId;
        plrOpts.propIndex = 0;
    }
}
JSONRequest.on("debugView", (evd) => {
    let pos = Vector3.fromLocation(evd.orgEvd.source.location).floor();
    let plr = Player.get(evd.id);
    let block = plr.dimension.dimension.getBlock(new BlockLocation(pos.x, pos.y, pos.z));
    checkBlock(block, evd.id);
    let data = block.permutation;
    let str = `§b${data.type.id}`;
    let props = data.getAllProperties();
    props.forEach((v) => {
        str += `\n§5${v.name}: §d${v.value}`;
    });
    let tags = data.getTags();
    tags.forEach((v) => (str += `\n§a#${v}`));
    plr.executeCommand(`title @s actionbar ${str}`);
});
JSONRequest.on("debugAlter", (evd) => {
    let pos = Vector3.fromLocation(evd.orgEvd.source.location).floor();
    let plr = Player.get(evd.id);
    let block = plr.dimension.dimension.getBlock(new BlockLocation(pos.x, pos.y, pos.z));
    checkBlock(block, evd.id);
    let plrOpts = settings[evd.id];
    let data = block.permutation;
    let props = data.getAllProperties();
    if (props.length <= 0)
        if (block.type.canBeWaterlogged) {
            block.isWaterlogged = !block.isWaterlogged;
            plr.executeCommand(`title @s actionbar "waterlogged" to ${block.isWaterlogged}`);
        } else return plr.executeCommand(`title @s actionbar ${data.type.id} has no properties`);
    let prop = props.find((v, i) => i === plrOpts.propIndex);
    if (props.length > plrOpts.propIndex) {
        let index = prop.validValues.findIndex((v) => v == prop.value);
        if (!prop.validValues[index + 1]) {
            prop.value = prop.validValues[0];
        } else prop.value = prop.validValues[index + 1];
        block.setPermutation(data);
        plr.executeCommand(`title @s actionbar "${prop.name}" to ${prop.value}`);
    } else {
        block.isWaterlogged = !block.isWaterlogged;
        plr.executeCommand(`title @s actionbar "waterlogged" to ${block.isWaterlogged}`);
    }
});
JSONRequest.on("debugSwap", (evd) => {
    let pos = Vector3.fromLocation(evd.orgEvd.source.location).floor();
    let plr = Player.get(evd.id);
    let block = plr.dimension.dimension.getBlock(new BlockLocation(pos.x, pos.y, pos.z));
    checkBlock(block, evd.id);
    let plrOpts = settings[evd.id];
    let data = block.permutation;
    let props = data.getAllProperties();
    if (props.length <= 0)
        if (block.type.canBeWaterlogged) {
            return plr.executeCommand(`title @s actionbar selected "waterlogged" (${block.isWaterlogged})`);
        } else return plr.executeCommand(`title @s actionbar ${data.type.id} has no properties`);
    if (props.length <= plrOpts.propIndex + 1) {
        if (props.length === plrOpts.propIndex + 1 && block.type.canBeWaterlogged) {
            plrOpts.propIndex++;
            return plr.executeCommand(`title @s actionbar selected "waterlogged" (${block.isWaterlogged})`);
        } else plrOpts.propIndex = 0;
    } else plrOpts.propIndex++;
    plr.executeCommand(`title @s actionbar selected "${props[plrOpts.propIndex].name}" (${props[plrOpts.propIndex].value})`);
});