import { MinecraftEffectTypes, World, } from "mojang-minecraft"; import CommandHandler from "./commandhandler.js"; import Selector from "./selector.js"; import Vector2 from "./vector2.js"; import Scoreboard from "./scoreboard.js"; let playerIdObj = Scoreboard.initialize("mbcPlayerId"); export default class Player { constructor(id) { this.id = id; } static get(playerId) { if (typeof playerId === "string") { playerId = playerIdObj.get(playerId); } return new Player(playerId); } get selector() { let selector = new Selector(`p`); selector.scores = { mbcPlayerId: this.id, }; return selector; } get player() { if (!this.hasLoadedEntity()) throw new Error("Unable to grab this player's minecraft instance, the player is not online"); CommandHandler.run(`effect ${this.selector.toString()} fatal_poison 1 124 true`); let player = World.getPlayers().find((v) => { let eff = v.getEffect(MinecraftEffectTypes.fatalPoison); return eff && eff.amplifier === 124; }); if (player) CommandHandler.run(`effect ${this.selector.toString()} fatal_poison 0 0 true`); return player; } get dimension() { if (!this.isOnline()) throw new Error("Unable to grab this player's dimension, the player is not online"); const dimensions = ["overworld", "the end", "nether"]; for (let i = 0; i < 3; i++) { let dimension = World.getDimension(dimensions[i]); let selector = this.selector; selector.range = new Vector2(0.01, 0); let cmd = CommandHandler.run(`testfor ${selector.toString()}`, dimension); if (!cmd.error) { return { name: dimensions[i], dimension }; } } throw new Error("This player is not currently in a dimension"); } get inventory() { throw new Error("Disabled, waiting for inventory access"); let inv = this.player.getComponent("inventory"); return inv; } isOnline() { return !CommandHandler.run(`testfor ${this.selector.toString()}`).error; } hasLoadedEntity() { let sel = this.selector; sel.selectorType = "e"; sel.type = "player"; return !CommandHandler.run(`testfor ${sel.toString()}`).error; } isAlive() { let selector = new Selector("e"); selector.type = "player"; selector.scores = { mbcPlayerId: this.id, }; return !CommandHandler.run(`testfor ${selector.toString()}`).error; } sendMsg(msg) { this.executeCommand(`tellraw @s {"rawtext":[{"text":${JSON.stringify(msg)}}]}`); } executeCommand(cmd) { return CommandHandler.run(`execute ${this.selector} ~~~ ${cmd}`); } }