import { BlockLocation, Location } from "mojang-minecraft"; export default class Vector3 { constructor(x = 0, y = 0, z = 0) { this.x = x; this.y = y; this.z = z; } static fromLocation(loc) { return new this(loc.x, loc.y, loc.z); } static fromObject(obj) { return new this(obj.x, obj.y, obj.z); } add(other) { return new Vector3(this.x + other.x, this.y + other.y, this.z + other.z); } multiply(num) { return new Vector3(this.x * num, this.y * num, this.z * num); } subtract(other) { other = other.multiply(-1); return new Vector3(this.x + other.x, this.y + other.y, this.z + other.z); } divide(num) { return new Vector3(this.x / num, this.y / num, this.z / num); } mod(num) { return new Vector3(this.x % num, this.y % num, this.z % num); } runMathFunc(func, ...args) { return new Vector3(func(this.x, ...args), func(this.y, ...args), func(this.z, ...args)); } round() { return this.runMathFunc(Math.round); } floor() { return this.runMathFunc(Math.floor); } trunc() { return this.runMathFunc(Math.trunc); } equals(other) { return this.x === other.x && this.y === other.y && this.z === other.z; } toString() { return `${this.x}, ${this.y}, ${this.z}`; } toBlockLocation() { let floored = this.floor(); return new BlockLocation(floored.x, floored.y, floored.z); } toLocation() { return new Location(this.x, this.y, this.z); } }